/*
**  EPIwm
**  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** icon_draw.c
** 
** Made by (Julien Mulot)
** Login   <mulot@epita.fr>
** 
** Started on  Sun Apr 11 17:00:15 1999 Julien Mulot
 ** Last update Wed May 12 02:13:25 1999 Julien Mulot
*/

#include "epiwm.h"

int			set_btn_position(titlebar, align, pos)
     Window		titlebar;
     short		align;
     int		pos;
{
  XWindowAttributes	attrib;
  
  XGetWindowAttributes(gl_dpy, titlebar, &attrib);
  if ((gl_epiwin.titlebar.position == TOP) 
      || (gl_epiwin.titlebar.position == BOTTOM))
    {
      if (align == ALIGN_LEFT)
	return (pos);
      if (align == ALIGN_RIGHT)
	return ((attrib.width - pos - gl_epiwin.btn_width >= 0) ?
		(attrib.width - pos) : 0);
      if (align == ALIGN_CENTER)
	return (attrib.width / 2 + pos);
    }
  else
    {
      if (align == ALIGN_LEFT)
	return (pos);
      if (align == ALIGN_RIGHT)
	return ((attrib.height - pos - gl_epiwin.btn_height >= 0) ?
		(attrib.height - pos) : 0);
      if (align == ALIGN_CENTER)
	return (attrib.height / 2 + pos);
    }
  return (0);
}

void			draw_icon_resize(icon, state)
     Window			icon;
     char			*state;
{
  XWindowAttributes	attrib;
  /*  XPoint		points[3];*/
  
  XGetWindowAttributes(gl_dpy, icon, &attrib);
  /*
    points[0].x = 0;
    points[0].y = attrib.height / 2 - 1; 
    points[1].x = attrib.width / 2;
    points[1].y = attrib.height / 2 - 1; 
    points[2].x = attrib.width / 2;
    points[2].y = attrib.height; 
    XDrawLines(gl_dpy, icon, gl_epiwin.titlebar.font_active, points, 3,
    CoordModeOrigin);
  */
  if (!strcmp("active", state))
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		     0, 0, 2 * attrib.width / 3, 2 * attrib.height / 3);
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		     attrib.width / 3, attrib.height / 3,
		     2 * attrib.width /3 - 1, 2 * attrib.height / 3 - 1);
    }
  else
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		     0, 0, 2 * attrib.width / 3, 2 * attrib.height / 3);
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		     attrib.width / 3, attrib.height / 3,
		     2 * attrib.width /3 - 1, 2 * attrib.height / 3 - 1);
    }
}

void			draw_icon_max(icon, state)
     Window			icon;
     char			*state;
{
  XWindowAttributes	attrib;
  
  XGetWindowAttributes(gl_dpy, icon, &attrib);
  if (!strcmp("active", state))
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		     0, 0, attrib.width - 1, attrib.height - 1);
      XFillRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active, 0, 0,
		     attrib.width, attrib.height / 3);
    }
  else
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		     0, 0, attrib.width - 1, attrib.height - 1);
      XFillRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive, 0, 0,
		     attrib.width, attrib.height / 3);
    }
}

void			draw_icon_iconify(icon, state)
     Window			icon;
     char			*state;
{
  XWindowAttributes	attrib;
  
  XGetWindowAttributes(gl_dpy, icon, &attrib);
  if (!strcmp("active", state))
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		     0, 0, attrib.width - 1, attrib.height - 1);
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		     0, attrib.height / 2,
		     attrib.width / 2 - 1, attrib.height / 2 - 1);
    }
  else
    {
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		     0, 0, attrib.width - 1, attrib.height - 1);
      XDrawRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		     0, attrib.height / 2,
		     attrib.width / 2 - 1, attrib.height / 2 - 1);
    }
}


void			draw_icon_close(icon, state)
     Window			icon;
     char			*state;
{
  
}

void			draw_icon_shade(icon, state)
     Window			icon;
     char			*state;
{
  XWindowAttributes	attrib;
  
  XGetWindowAttributes(gl_dpy, icon, &attrib);
  if (!strcmp("active", state))
    XFillRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_active,
		   0, attrib.height / 3,
		   attrib.width, attrib.height / 3 - 1);
  else
    XFillRectangle(gl_dpy, icon, gl_epiwin.titlebar.font_inactive,
		   0, attrib.height / 3,
		   attrib.width, attrib.height / 3 - 1);
}





