/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** menu.c
 **
 ** Made by (Julien Mulot)
 ** Login   <mulot@epita.fr>
 **
 ** Started on  Thu Feb 18 16:38:48 1999 Julien Mulot
 ** Last update Tue May 18 21:00:36 1999 mulot
 */

#include "epiwm.h"

void	set_dim_menu()
{
   if (gl_menu.lngst_str)
     {
	gl_menu.width = (MENU_SPACE + XTextWidth(gl_menu.font,
					 gl_menu.lngst_str,
						 strlen(gl_menu.lngst_str)));
	if (gl_menu.width < MENU_MINI_WIDTH)
	  gl_menu.width = MENU_MINI_WIDTH;
     }
}

char	*extract_str(str, word)
char	*str;
char	*word;
{
   while (strncasecmp(str, word, strlen(word)))
     str++;
   return (cut_str(str, word));
}

char		*extract_name(str)
char		*str;
{
   char		*tokens[1024];
   static char	tmpstring[1024];
   int		i;
  
   i = 0;
   strncpy(tmpstring, str, 1024);
   tokens[i] = strtok(tmpstring, "\"");
   while ((tokens[++i] = strtok(NULL, "\"")));
   tokens[i] = NULL;
   return (tokens[1]);
}

void		add_menu_elt(menu_list, elt, cmd)
t_menu_pos		**menu_list;
char		*elt;
char		*cmd;
{
   t_menu_apps	**p_apps_list;
  
   p_apps_list = (*menu_list)->pos;
   while ((*p_apps_list) != NULL)
     p_apps_list = &((*p_apps_list)->next_elt);
   (*p_apps_list) = (t_menu_apps *) malloc(sizeof(t_menu_apps));
   (*p_apps_list)->elt = (char *) malloc(sizeof(char)
					 * (strlen(elt) + 1));
   strcpy((*p_apps_list)->elt, elt);
   (*p_apps_list)->cmd = (char *) malloc(sizeof(char)
					 * (strlen(cmd) + 1));
   strcpy((*p_apps_list)->cmd, cmd);
   (*p_apps_list)->next_elt = NULL;
   (*p_apps_list)->menu = NULL;
   (*menu_list)->nb_elt++;
}

void		add_menu_sub(p_apps_list, menu_address, name)
t_menu_apps	**p_apps_list;
t_menu_pos		**menu_address;
char		*name;
{
   while ((*p_apps_list) != NULL)
     p_apps_list = &((*p_apps_list)->next_elt);
   (*p_apps_list) = (t_menu_apps *) malloc(sizeof(t_menu_apps));
   (*p_apps_list)->elt = (char *) malloc(sizeof(char) * (strlen(name) + 1));
   strcpy((*p_apps_list)->elt, name);
   (*p_apps_list)->next_elt = NULL;
   (*p_apps_list)->menu = (t_menu_apps *) malloc(sizeof(t_menu_apps));
   (*p_apps_list)->menu->elt = (char *) malloc(sizeof(char)
					       * (strlen(name) + 1));
   strcpy((*p_apps_list)->menu->elt, name);
   (*p_apps_list)->menu->next_elt = NULL;
   (*p_apps_list)->menu->menu = ((*p_apps_list)->menu);
   while ((*menu_address) != NULL)
     menu_address = &((*menu_address)->next);
   (*menu_address) = (t_menu_pos *) malloc(sizeof(t_menu_pos));
   (*menu_address)->menu_name = (char *) malloc(sizeof(char)
						* (strlen(name) + 1));
   strcpy((*menu_address)->menu_name, name);
   (*menu_address)->pos = &((*p_apps_list)->menu);
   (*menu_address)->here = 0;
   (*menu_address)->stick = 0;
   (*menu_address)->win = 0;
   (*menu_address)->nb_elt = 0;
}

void		sub_menu_detect(menu_name, line)
char		*menu_name;
char		*line;
{
   t_menu_pos	**p_menu_pos;
  
   p_menu_pos = &menu_pos;
   while (((strcmp(((*p_menu_pos)->menu_name), menu_name))
	   != 0) && (((*p_menu_pos)->next) != NULL))
     p_menu_pos = &((*p_menu_pos)->next);
   if (!(strcmp(((*p_menu_pos)->menu_name), menu_name)))
     {
	(*p_menu_pos)->nb_elt++;
	add_menu_sub((*p_menu_pos)->pos, &menu_pos,
		     extract_name(line));
	if (gl_menu.lngst_str)
	  {
	     if (strlen(extract_name(line)) > strlen(gl_menu.lngst_str))
	       {
		  free(gl_menu.lngst_str);
		  gl_menu.lngst_str =
		    (char *) malloc(sizeof(char)
				    * (strlen(extract_name(line)) + 1));
		  strcpy(gl_menu.lngst_str, extract_name(line));
	       }
	  }
	else
	  {
	     gl_menu.lngst_str =
	       (char *) malloc(sizeof(char)
			       * (strlen(extract_name(line)) + 1));
	     strcpy(gl_menu.lngst_str, extract_name(line));
	  }
     }
}

void		elt_detect(menu_name, line)
char		*menu_name;
char		*line;
{
   t_menu_pos	**p_menu_pos;
  
   p_menu_pos = &menu_pos;
   while (((strcmp(((*p_menu_pos)->menu_name), menu_name)) != 0)
	  && (((*p_menu_pos)->next) != NULL))
     p_menu_pos = &((*p_menu_pos)->next);
   if (!(strcmp(((*p_menu_pos)->menu_name), menu_name)))
     {
	add_menu_elt(p_menu_pos, extract_name(line),
		     extract_str(line, "Exec "));
	if (gl_menu.lngst_str)
	  {
	     if (strlen(extract_name(line)) > strlen(gl_menu.lngst_str))
	       {
		  free(gl_menu.lngst_str);
		  gl_menu.lngst_str =
		    (char *) malloc(sizeof(char)
				    * (strlen(extract_name(line)) + 1));
		  strcpy(gl_menu.lngst_str, extract_name(line));
	       }
	  }
	else
	  {
	     gl_menu.lngst_str =
	       (char *) malloc(sizeof(char)
			       * (strlen(extract_name(line)) + 1));
	     strcpy(gl_menu.lngst_str, extract_name(line));
	  }
     }
}

void	menu_detect(menu_name, line, is_menu)
char	**menu_name;
char	*line;
char	*is_menu;
{
   if (!strcasecmp(index_file(line, 1), "End"))
     *is_menu = 0;
   else if (strcasecmp(index_file(line, 1), "Main"))
     {
	*is_menu = 1;
	*menu_name = (char *) malloc(sizeof(char) *
				     (strlen(extract_name(line)) + 1));
	strcpy(*menu_name, extract_name(line));
     }
   else
     {
	*is_menu = 1;
	*menu_name = (char *) malloc(sizeof(char) *
				     (strlen(extract_name(line)) + 1));
	strcpy(*menu_name, extract_name(line));
	add_menu_sub(&gl_menu_apps, &menu_pos, extract_name(line));
	if (gl_menu.lngst_str)
	  {
	    if (strlen(extract_name(line)) > strlen(gl_menu.lngst_str))
	      {
		free(gl_menu.lngst_str);
		gl_menu.lngst_str =
		  (char *) malloc(sizeof(char) * (strlen(*menu_name) + 1));
		strcpy(gl_menu.lngst_str, *menu_name);
	      }
	  }
	else
	  {
	    gl_menu.lngst_str =
	      (char *) malloc(sizeof(char) * (strlen(*menu_name) + 1));
	    strcpy(gl_menu.lngst_str, *menu_name);
	  }
     }
}

void	menu_build(file)
     FILE	*file;
{
  char	tmp[250];
  char	*tmp2;
  char	*menu_name;
  char	is_menu;
  
  is_menu = 0;
  menu_name = NULL;
  while (fgets(tmp, 300, file) != NULL)
    {
      if (strlen(tmp) != 1)
	tmp[strlen(tmp) - 1] = ' ';
      tmp2 = index_file(tmp, 0);
      if ((!strcasecmp(tmp2, "-")) && is_menu)
	elt_detect(menu_name, tmp);
      else if ((!strcasecmp(tmp2, "+")) && is_menu)
	sub_menu_detect(menu_name, tmp);
      else if (!strcasecmp(tmp2, "Menu"))
	menu_detect(&menu_name, tmp, &is_menu);
      else if (!strcasecmp(tmp2, "MenuColor"))
	{
	  if (!strcmp(index_file(tmp, 1),"H")||!strcmp(index_file(tmp, 1),"V"))
	    gradient(index_file(tmp, 2), index_file(tmp, 3),
		     index_file(tmp, 1), "menu", "active");
	  else
	    init_color("menu_color", index_file(tmp, 1));
	}
      else if (!strcasecmp(tmp2, "MenuFontInactiveColor"))
	init_font_color(&gl_menu.font_inactive, index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "MenuFontActiveColor"))
	init_font_color(&gl_menu.font_active, index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "MenuHighlight"))
	gl_menu.highlight = 1;
      else if (!strcasecmp(tmp2, "MenuHighlightColor"))
	init_color("menu_highlight", index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "MenuImage"))
	init_image(index_file(tmp, 1), "menu");
      else if (!strcasecmp(tmp2, "MenuAuto"))
	gl_menu.auto_menu = 1;
      else if (!strcasecmp(tmp2, "MenuFont"))
	{
	  gl_menu.font = XLoadQueryFont(gl_dpy, index_file(tmp, 1));
	  XSetFont(gl_dpy, gl_menu.font_active, gl_menu.font->fid);
	  XSetFont(gl_dpy, gl_menu.font_inactive, gl_menu.font->fid);
	}
    }
  set_dim_menu();
}
