/*
** menu_x.c
**
** Made by (mulot)
** Login   <mulot_j@epita.fr>
**
** Started on  Tue Mar  2 20:52:55 1999 mulot
 ** Last update Tue May 18 22:36:45 1999 Thomas Poindessous
*/

#include "epiwm.h"

#ifdef	  __Imlib__
void		draw_image_menu(menu)
     Window		menu;		
{
  int		width;
  int		height;
  Pixmap	pixmap;
  
  if (!(gl_menu.image = Imlib_load_image(gl_imlib_data, gl_menu.image_name)))
    {
      fprintf(stderr, "cannot load menu image\n");
      exit (1);
    }
  width = gl_menu.image->rgb_width;
  height = gl_menu.image->rgb_height;
  Imlib_render(gl_imlib_data, gl_menu.image, width, height);  
  pixmap = Imlib_move_image(gl_imlib_data, gl_menu.image);
  XSetWindowBackgroundPixmap(gl_dpy, menu, pixmap);  
  XClearWindow(gl_dpy, menu);
}
#endif

void		draw_menu_task()
{
   int		h_space;
   char		*name;
   int		text_width;
   t_win_list	*apps_list;
   
   h_space = 0;
   apps_list = gl_epiwin.first_win_group_list;
   XClearWindow(gl_dpy, gl_menu.menu_task);
   if (gl_menu.grad_type)
     draw_gradient(gl_menu.menu_task, "menu", "");
   while (apps_list)
     {
	h_space += 20;
	XFetchName(gl_dpy, apps_list->p_t_win->parent, &name);
	text_width = XTextWidth(gl_menu.font, name, strlen(name));
	XDrawString(gl_dpy, gl_menu.menu_task, gl_menu.font_inactive,
		    (gl_menu.task_width - text_width) / 2, h_space,
		    name, strlen(name));
	if (apps_list->p_t_win == gl_epiwin.current)
	  draw_triangle(gl_menu.menu_task, 2, h_space - 8, "active");
	apps_list = apps_list->next_elt;
     }
   if (name)
     free(name);
}

void		draw_menu(p_menu_apps, p_menu_pos)
t_menu_apps	**p_menu_apps;
t_menu_pos		**p_menu_pos;
{
   int		h_space;
   int		text_width;
   
   h_space = 0;
   p_menu_apps = &((*p_menu_apps)->next_elt);
   if (gl_menu.grad_type)
     draw_gradient((*p_menu_pos)->win, "menu", "");
   while ((*p_menu_apps) != NULL)
     {
	h_space += 20;
	(*p_menu_pos)->win_pos = h_space;
	text_width = XTextWidth(gl_menu.font, (*p_menu_apps)->elt,
				strlen((*p_menu_apps)->elt));
	XDrawString(gl_dpy, (*p_menu_pos)->win, gl_menu.font_inactive,
		    (gl_menu.width - text_width) / 2,
		    (*p_menu_pos)->win_pos, (*p_menu_apps)->elt,
		    strlen((*p_menu_apps)->elt));
	if (((*p_menu_apps)->menu) != NULL)
	  draw_triangle((*p_menu_pos)->win, gl_menu.width - 14, 
			(*p_menu_pos)->win_pos - 8, "inactive");
	p_menu_apps = &((*p_menu_apps)->next_elt);
     }
}

void		draw_triangle(win, x, y, state)
Window	win;
int	x;
int	y;
char	*state;
{
   XPoint	points[4];
   
   points[0].x = x;
  points[0].y = y;
  points[1].x = x + 9;
  points[1].y = y + 5;
  points[2].x = x;
  points[2].y = y + 10;
  points[3].x = x;
  points[3].y = y;
  if (strcmp(state, "active"))
    XDrawLines(gl_dpy, win, gl_menu.font_inactive, points, 4,
	       CoordModeOrigin);  
  else
    XFillPolygon(gl_dpy, win, gl_menu.font_active, points, 4,
		 Nonconvex, CoordModeOrigin);  
}

void		destroy_menu(p_menu_pos, keep_menu)
     t_menu_pos	**p_menu_pos;
     char	*keep_menu;
{
  if (keep_menu)
    while ((*p_menu_pos) != NULL)
      {
	if (((*p_menu_pos)->here) && (!(*p_menu_pos)->stick) &&
	    (strcmp((*p_menu_pos)->menu_name, keep_menu)))
	  {
	    XDestroyWindow(gl_dpy, (*p_menu_pos)->win);
	    (*p_menu_pos)->here = 0;
	  }
	p_menu_pos = &(*p_menu_pos)->next;
      }
  else
    while ((*p_menu_pos) != NULL)
      {
	if (((*p_menu_pos)->here) && (!(*p_menu_pos)->stick))
	  {
	    XDestroyWindow(gl_dpy, (*p_menu_pos)->win);
	    (*p_menu_pos)->here = 0;
	  }
	p_menu_pos = &(*p_menu_pos)->next;
      }
}

int	menu_set_height(menu_list)
     t_menu_pos	*menu_list;
{
  if (menu_list->nb_elt)
    return (menu_list->nb_elt * 22);
  else
    return (1);
}

void			menu_apps(title, pos_x, pos_y)
     char			*title;
     int			pos_x;
     int			pos_y;
{
  XSetWindowAttributes	attrib;
  t_menu_pos		**p_menu_pos;
  
  p_menu_pos = &menu_pos;
  while (strcmp(((*p_menu_pos)->menu_name), title))
    p_menu_pos = &((*p_menu_pos)->next);
  if (!((*p_menu_pos)->here))
    {
      if ((pos_x + gl_menu.width) > gl_scr_info.dpy_width)
	pos_x = gl_scr_info.dpy_width - gl_menu.width;
      if ((pos_y + menu_set_height(*p_menu_pos)) > gl_scr_info.dpy_height)
	pos_y = gl_scr_info.dpy_height - menu_set_height(*p_menu_pos);
      (*p_menu_pos)->win =
	XCreateSimpleWindow(gl_dpy,
			    gl_scr_info.root_win,
			    pos_x, pos_y,
			    gl_menu.width, menu_set_height(*p_menu_pos),
			    1, BlackPixel(gl_dpy, gl_scr_info.screen),
			    gl_menu.color.pixel);
      attrib.override_redirect = 1;
      XChangeWindowAttributes(gl_dpy, (*p_menu_pos)->win,
			      CWOverrideRedirect, &attrib);
      XSelectInput(gl_dpy, (*p_menu_pos)->win, ButtonPressMask | ExposureMask 
		   | PointerMotionMask | EnterWindowMask | LeaveWindowMask);
#ifdef	  __Imlib__
      if (gl_menu.image_name)
	draw_image_menu((*p_menu_pos)->win);
      else
#endif
	if (gl_menu.grad_type)
	  draw_gradient((*p_menu_pos)->win, "menu", "");
      XMapWindow(gl_dpy, (*p_menu_pos)->win);
      ((*p_menu_pos)->here) = 1;
      draw_menu((*p_menu_pos)->pos, p_menu_pos);
    }
  else
    destroy_menu(p_menu_pos, NULL);
}


void		menu_task_click(pos_x, pos_y)
     int		pos_x;
     int		pos_y;
{
  int			i;
  int			elt_pos;
  t_win_list		*apps_list;
  t_mouse_move_win	list;
  
  apps_list = gl_epiwin.first_win_group_list;
  elt_pos = pos_y / 20;
  for (i = 0; i < elt_pos; i++)
    {
      if (!apps_list->next_elt)
	break;
      apps_list = apps_list->next_elt;
    }
  if (apps_list->p_t_win->iconify_win)
    {
      list.temp = apps_list->p_t_win;
      mouse_uniconify(&list);
    }
  XRaiseWindow(gl_dpy, apps_list->p_t_win->parent);
  window_state(apps_list->p_t_win, "active");
  draw_menu_task();
}

void		menu_task_move(pos_x, pos_y)
int		pos_x;
int		pos_y;
{
   int		i;
   int		elt_pos;
   int		text_width;
   t_win_list	*apps_list;
   char		*name;
   
   apps_list = gl_epiwin.first_win_group_list;
   elt_pos = pos_y / 20;
   for (i = 0; i < elt_pos; i++)
     {
	if (!apps_list)/*->next_elt)*/
	  break;
	apps_list = apps_list->next_elt;
     }
   if (apps_list)
     {
	if (gl_menu.current_task != &(apps_list->p_t_win->parent))
	  {
	     draw_menu_task();
	     XFetchName(gl_dpy, apps_list->p_t_win->parent, &name);
	     text_width = XTextWidth(gl_menu.font, name, strlen(name));
	     XDrawString(gl_dpy, gl_menu.menu_task, gl_menu.font_active,
			 (gl_menu.task_width - text_width) / 2,
			 (elt_pos + 1)* 20, name, strlen(name));
	     free(name);
	     gl_menu.current_task = &(apps_list->p_t_win->parent);
	  }
     }
}

void			menu_task(pos_x, pos_y)
int			pos_x;
     int			pos_y;
{
  XSetWindowAttributes	attrib;
  char			*name;
  int			text_width;
  t_win_list		*apps_list; 

  if (!gl_menu.here_task)
    {
      text_width = 0;
      apps_list = gl_epiwin.first_win_group_list;
      while (apps_list)
	{
	  XFetchName(gl_dpy, apps_list->p_t_win->parent, &name);
	  if (XTextWidth(gl_menu.font, name, strlen(name)) > text_width)
	    text_width = XTextWidth(gl_menu.font, name, strlen(name));
	  apps_list = apps_list->next_elt;
	}
      gl_menu.task_width = text_width + MENU_SPACE;
      if (gl_menu.task_width < MENU_MINI_WIDTH)
	gl_menu.task_width = MENU_MINI_WIDTH;
      gl_menu.menu_task = 
	XCreateSimpleWindow(gl_dpy,
			    gl_scr_info.root_win,
			    pos_x, pos_y, gl_menu.task_width,
			    (gl_epiwin.nb_elt + 1) * 20,
			    1, BlackPixel(gl_dpy, gl_scr_info.screen),
			    gl_menu.color.pixel);
      attrib.override_redirect = 1;
      XChangeWindowAttributes(gl_dpy, gl_menu.menu_task,
			      CWOverrideRedirect, &attrib);
      XSelectInput(gl_dpy, gl_menu.menu_task, ButtonPressMask | ExposureMask 
		   | PointerMotionMask);
#ifdef	  __Imlib__
      if (gl_menu.image_name)
	draw_image_menu(gl_menu.menu_task);
      else
#endif
	if (gl_menu.grad_type)
	  {
	    draw_gradient(gl_menu.menu_task, "menu", "");
	    printf("gradient\n");
	  }
      XMapWindow(gl_dpy, gl_menu.menu_task);
      gl_menu.here_task = 1;
      draw_menu_task();
    }
  else
    {
      XDestroyWindow(gl_dpy, gl_menu.menu_task);
      gl_menu.current_task = NULL;
      gl_menu.here_task = 0;
    }
}

void			menu_prop(win, pos_x, pos_y)
     Window			win;
     int			pos_x;
     int			pos_y;
{
  XSetWindowAttributes	attrib;
  XWindowAttributes	attr_win;
  t_win			*temp;
  int			text_width;
  int			x;
  int			y;
  
  if (!gl_menu.here_prop)
    {
      temp = search_elt(win);
      if (temp)
	{
	  XGetWindowAttributes(gl_dpy, temp->parent, &attr_win);
	  x = attr_win.x + pos_x;
	  y = attr_win.y + gl_epiwin.titlebar.height;
	}
      else
	{
	  x = pos_x;
	  y = pos_y;
	}
      text_width = XTextWidth(gl_menu.font, "Properties",
			      strlen("Properties"));
      gl_menu.menu_prop =
	XCreateSimpleWindow(gl_dpy,
			    gl_scr_info.root_win,
			    x, y, 
			    gl_menu.width, 200, 1,
			    BlackPixel(gl_dpy, gl_scr_info.screen),
			    gl_menu.color.pixel);
      attrib.override_redirect = 1;
      XChangeWindowAttributes(gl_dpy, gl_menu.menu_prop,
			      CWOverrideRedirect, &attrib);
      XSelectInput(gl_dpy, gl_menu.menu_prop, ButtonPressMask | ExposureMask 
		   | PointerMotionMask | EnterWindowMask | LeaveWindowMask);
      XMapWindow(gl_dpy, gl_menu.menu_prop);
      gl_menu.here_prop = 1;
      XDrawString(gl_dpy, gl_menu.menu_prop, gl_menu.font_inactive,
		  (gl_menu.width - text_width) / 2, 20,
		  "Properties", strlen("Properties"));
    }
  else
    {
      XDestroyWindow(gl_dpy, gl_menu.menu_prop);
      gl_menu.here_prop = 0;
    }
}

void		menu_display(win, pos_x, pos_y, button_state)
     Window          win;
     int             pos_x;
     int             pos_y;
     unsigned int    button_state;
{
  if (win == gl_scr_info.root_win)
    {
      if (button_state == 1)
	menu_apps(gl_menu_apps->elt, pos_x, pos_y);
      else if (button_state == 2)
	menu_task(pos_x, pos_y);
      else if (button_state == 3)
	menu_prop(win, pos_x, pos_y);
    } 
  else if (button_state == 3)
    menu_prop(win, pos_x, pos_y);
}

void			menu_click(menu, pos_x, pos_y, button_state)
     t_menu_pos		*menu;
     int			pos_x;
     int			pos_y;
     unsigned int		button_state;
{
  int			elt_pos;
  int			i;
  t_menu_apps		*p_menu_apps;
  XWindowAttributes	attrib;
  
  p_menu_apps = (*menu->pos)->next_elt;
  elt_pos = pos_y / 20 + 1;
  for (i = 0; i < elt_pos - 1; i++)
    {
      p_menu_apps = p_menu_apps->next_elt;
      if (!p_menu_apps)
	break;
    }
  if (p_menu_apps)
    {
      if (!p_menu_apps->menu)
	{
	  system(p_menu_apps->cmd);
	  destroy_menu(&menu_pos, NULL);
	}
      else
	{
	  destroy_other_menus((*(menu->pos))->next_elt, p_menu_apps->elt);
	  XGetWindowAttributes(gl_dpy, menu->win, &attrib);
	  menu_apps(p_menu_apps->elt, attrib.x + gl_menu.width + 1,
		    attrib.y + pos_y);
	}
    }
}

void			menu_move(menu, pos_x, pos_y)
     t_menu_pos		*menu;
     int		pos_x;
     int		pos_y;
{
  int			elt_pos;
  int			i;
  t_menu_apps		*p_menu_apps;
  XWindowAttributes	attrib;
  
  p_menu_apps = (*menu->pos)->next_elt;
  elt_pos = pos_y / 20 + 1;
  for (i = 0; i < elt_pos - 1; i++)
    {
      p_menu_apps = p_menu_apps->next_elt;
      if (!p_menu_apps)
	break;
    }
  if (p_menu_apps)
    {
      if (gl_menu.current_menu != &(p_menu_apps->elt))
	{
	  if (p_menu_apps->menu)
	    {
	      destroy_other_menus((*(menu->pos))->next_elt, p_menu_apps->elt);
	      XGetWindowAttributes(gl_dpy, menu->win, &attrib);
	      menu_apps(p_menu_apps->elt, attrib.x + gl_menu.width + 1,
			attrib.y + pos_y);
	      gl_menu.current_menu = &(p_menu_apps->elt);
	    }
	  else
	    {
	      destroy_other_menus((*(menu->pos))->next_elt, menu->menu_name);
	      gl_menu.current_menu = NULL;
	    }
	}
    }
}

void		destroy_other_menus(p_menu, name)
     t_menu_apps	*p_menu;
     char		*name;
{
  t_menu_pos	**p_menu_pos;
  
  while (p_menu)
    {
      if (p_menu->menu)
	{
	     p_menu_pos = &menu_pos;
	     while (strcmp(((*p_menu_pos)->menu_name), p_menu->elt))
	       p_menu_pos = &((*p_menu_pos)->next);
	     if (strcmp((*p_menu_pos)->menu_name, name))
	       destroy_menu(p_menu_pos, name);
	}
	p_menu = p_menu->next_elt;
    }
}

