/*
** window_init.c
**
** Made by (mulot)
** Login   <mulot_j@epita.fr>
**
** Started on  Wed Mar 17 13:33:36 1999 mulot
 ** Last update Tue May 18 20:59:46 1999 mulot
*/

#include "epiwm.h"

void	set_titlebar_position(position)
char	*position;
{
  if (!strcmp("top", position))
      gl_epiwin.titlebar.position = TOP;
  else if (!strcmp("left", position))
    gl_epiwin.titlebar.position = LEFT;
  else if (!strcmp("right", position))
    gl_epiwin.titlebar.position = RIGHT;
  else if (!strcmp("bottom", position))
    gl_epiwin.titlebar.position = BOTTOM;
}

int	set_title_position()
{
#define SPACE 4
  int	space;
  
  space = 0;
  if (!strcmp("left", gl_epiwin.titlebar.align))
    {
      if (gl_epiwin.is_btn_iconify &&
	  (gl_epiwin.align_btn_iconify == ALIGN_LEFT))
	if (space < gl_epiwin.pos_btn_iconify)
	  space = gl_epiwin.pos_btn_iconify;
      if (gl_epiwin.is_btn_max &&
	  (gl_epiwin.align_btn_max == ALIGN_LEFT))
	if (space < gl_epiwin.pos_btn_max)
	  space = gl_epiwin.pos_btn_max;
      if (gl_epiwin.is_btn_resize &&
	  (gl_epiwin.align_btn_resize == ALIGN_LEFT))
	if (space < gl_epiwin.pos_btn_resize)
	  space = gl_epiwin.pos_btn_resize;
      if (gl_epiwin.is_btn_shade &&
	  (gl_epiwin.align_btn_shade == ALIGN_LEFT))
	if (space < gl_epiwin.pos_btn_shade)
	  space = gl_epiwin.pos_btn_shade;
      return (space + gl_epiwin.btn_width + SPACE);
    }
  if (!strcmp("right", gl_epiwin.titlebar.align))
    {
      if (gl_epiwin.is_btn_iconify &&
	  (gl_epiwin.align_btn_iconify == ALIGN_RIGHT))
	if (space < gl_epiwin.pos_btn_iconify)
	  space = gl_epiwin.pos_btn_iconify;
      if (gl_epiwin.is_btn_max &&
	  (gl_epiwin.align_btn_max == ALIGN_RIGHT))
	if (space < gl_epiwin.pos_btn_max)
	  space = gl_epiwin.pos_btn_max;
      if (gl_epiwin.is_btn_resize &&
	  (gl_epiwin.align_btn_resize == ALIGN_RIGHT))
	if (space < gl_epiwin.pos_btn_resize)
	  space = gl_epiwin.pos_btn_resize;
      if (gl_epiwin.is_btn_shade &&
	  (gl_epiwin.align_btn_shade == ALIGN_RIGHT))
	if (space < gl_epiwin.pos_btn_shade)
	  space = gl_epiwin.pos_btn_shade;
      return (space + gl_epiwin.btn_width + SPACE);
    }
  return (0);
}

void	btn_iconify_build(align, pos)
     char	*align;
     int	pos;
{
  gl_epiwin.is_btn_iconify = 1;
  gl_epiwin.pos_btn_iconify = pos;
  if (!strcmp(align, "center"))
    gl_epiwin.align_btn_iconify = ALIGN_CENTER;
  else if (!strcmp(align, "right"))
    gl_epiwin.align_btn_iconify = ALIGN_RIGHT;
  else
    gl_epiwin.align_btn_iconify = ALIGN_LEFT;
}

void	btn_max_build(align, pos)
     char	*align;
     int	pos;
{
  gl_epiwin.is_btn_max= 1;
  gl_epiwin.pos_btn_max = pos;
  if (!strcmp(align, "center"))
    gl_epiwin.align_btn_max = ALIGN_CENTER;
  else if (!strcmp(align, "right"))
    gl_epiwin.align_btn_max = ALIGN_RIGHT;
  else
    gl_epiwin.align_btn_max = ALIGN_LEFT;
}

void	btn_resize_build(align, pos)
     char	*align;
     int	pos;
{
  gl_epiwin.is_btn_resize = 1;
  gl_epiwin.pos_btn_resize = pos;
  if (!strcmp(align, "center"))
    gl_epiwin.align_btn_resize = ALIGN_CENTER;
  else if (!strcmp(align, "right"))
    gl_epiwin.align_btn_resize = ALIGN_RIGHT;
  else
    gl_epiwin.align_btn_resize = ALIGN_LEFT;
}


void	btn_shade_build(align, pos)
     char	*align;
     int	pos;
{
  gl_epiwin.is_btn_shade = 1;
  gl_epiwin.pos_btn_shade = pos;
  if (!strcmp(align, "center"))
    gl_epiwin.align_btn_shade = ALIGN_CENTER;
  else if (!strcmp(align, "right"))
    gl_epiwin.align_btn_shade = ALIGN_RIGHT;
  else
    gl_epiwin.align_btn_shade = ALIGN_LEFT;
}


void	btn_close_build(align, pos)
     char	*align;
     int	pos;
{
  gl_epiwin.is_btn_close = 1;
  gl_epiwin.pos_btn_close = pos;
  if (!strcmp(align, "center"))
    gl_epiwin.align_btn_close = 2;
  else if (!strcmp(align, "right"))
    gl_epiwin.align_btn_close = 3;
  else
    gl_epiwin.align_btn_close = 1;
}


void		window_build(file)
     FILE		*file;
{
  char		tmp[250];
  char		*tmp2;
  
  while (fgets(tmp, 300, file) != NULL)
    {
      if (strlen(tmp) != 1)
	tmp[strlen(tmp) - 1] = ' ';
      tmp2 = index_file(tmp, 0);
      if (!strcasecmp(tmp2, "BorderActiveColor"))
	init_color("active", index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "BorderInactiveColor"))
	init_color("inactive", index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "BorderStickColor"))
	init_color("stick", index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "BorderWidth"))
	{
	  gl_epiwin.border_height = atoi(index_file(tmp, 1));
	  gl_epiwin.border_width = gl_epiwin.border_height;
	}
      else if (!strcasecmp(tmp2, "TitleFontActiveColor"))
	init_font_color(&gl_epiwin.titlebar.font_active, index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "TitleFontInactiveColor"))
	init_font_color(&gl_epiwin.titlebar.font_inactive, 
			index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "TitleActiveColor"))
	{
	  if (!strcmp(index_file(tmp, 1),"H")||!strcmp(index_file(tmp, 1),"V"))
	    gradient(index_file(tmp, 2), index_file(tmp, 3),
		     index_file(tmp, 1), "titlebar", "active");
	  else
	    init_color("title_active", index_file(tmp, 1));
	}
      else if (!strcasecmp(tmp2, "TitleInactiveColor"))
	{
	  if (!strcmp(index_file(tmp, 1),"H")||!strcmp(index_file(tmp, 1),"V"))
	    gradient(index_file(tmp, 2), index_file(tmp, 3),
		     index_file(tmp, 1), "titlebar", "inactive");
	  else
	    init_color("title_inactive", index_file(tmp, 1));
	}
      else if (!strcasecmp(tmp2, "TitleHeight"))
	gl_epiwin.titlebar.height = atoi(index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "TitleActiveImage"))
	init_image(index_file(tmp, 1), "title_active");
      else if (!strcasecmp(tmp2, "TitleInactiveImage"))
	init_image(index_file(tmp, 1), "title_inactive");
      else if (!strcasecmp(tmp2, "TitlePosition"))
	set_titlebar_position(index_file(tmp, 1));
      else if (!strcasecmp(tmp2, "TitleAlign"))
	{
	  gl_epiwin.titlebar.align =
	    (char *) malloc(sizeof(char) * (strlen(index_file(tmp, 1)) + 1));
	  strcpy(gl_epiwin.titlebar.align, index_file(tmp, 1));
	}
      else if (!strcasecmp(tmp2, "TitleFont"))
	{
	  gl_epiwin.titlebar.font = XLoadQueryFont(gl_dpy, 
						   index_file(tmp, 1));
	  XSetFont(gl_dpy, gl_epiwin.titlebar.font_active, 
		   gl_epiwin.titlebar.font->fid);
	  XSetFont(gl_dpy, gl_epiwin.titlebar.font_inactive, 
		   gl_epiwin.titlebar.font->fid);
	}
      else if (!strcasecmp(tmp2, "CloseButton"))
	btn_close_build(index_file(tmp, 1), atoi(index_file(tmp, 2)));
      else if (!strcasecmp(tmp2, "MaxButton"))
	btn_max_build(index_file(tmp, 1), atoi(index_file(tmp, 2)));
      else if (!strcasecmp(tmp2, "IconifyButton"))
	btn_iconify_build(index_file(tmp, 1), atoi(index_file(tmp, 2)));
      else if (!strcasecmp(tmp2, "ShadeButton"))
	btn_shade_build(index_file(tmp, 1), index_file(tmp, 2));
      else if (!strcasecmp(tmp2, "ResizeButton"))
	btn_resize_build(index_file(tmp, 1), atoi(index_file(tmp, 2)));
    }
  gl_epiwin.titlebar.space = set_title_position();
}
